VERSION 4.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "API Example .. Play WAV and MID"
   ClientHeight    =   4890
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   5670
   Height          =   5295
   Icon            =   "Form1.frx":0000
   KeyPreview      =   -1  'True
   Left            =   1080
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4890
   ScaleWidth      =   5670
   Top             =   1170
   Width           =   5790
   Begin VB.FileListBox File1 
      Height          =   2790
      Left            =   3000
      Pattern         =   "*.mid;*.wav"
      TabIndex        =   3
      Top             =   120
      Width           =   2415
   End
   Begin VB.DirListBox Dir1 
      Height          =   2280
      Left            =   240
      TabIndex        =   2
      Top             =   600
      Width           =   2415
   End
   Begin VB.DriveListBox Drive1 
      Height          =   315
      Left            =   240
      TabIndex        =   1
      Top             =   120
      Width           =   2415
   End
   Begin VB.CommandButton cmdQuit 
      Caption         =   "&Quit"
      BeginProperty Font 
         name            =   "MS Sans Serif"
         charset         =   0
         weight          =   700
         size            =   9.75
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   4560
      TabIndex        =   0
      Top             =   4440
      Width           =   975
   End
   Begin ComctlLib.Slider sldr1 
      Height          =   375
      Left            =   1920
      TabIndex        =   6
      Top             =   3720
      Visible         =   0   'False
      Width           =   1815
      _Version        =   65536
      _ExtentX        =   3201
      _ExtentY        =   661
      _StockProps     =   64
      Enabled         =   0   'False
      SmallChange     =   10
      TickStyle       =   3
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      Caption         =   "Position"
      Height          =   255
      Left            =   2040
      TabIndex        =   5
      Top             =   4200
      Visible         =   0   'False
      Width           =   1695
   End
   Begin VB.Label Label1 
      Caption         =   "Length"
      Height          =   255
      Left            =   3840
      TabIndex        =   4
      Top             =   3840
      Visible         =   0   'False
      Width           =   1455
   End
   Begin VB.Image imgStopBmp 
      Height          =   300
      Left            =   3240
      Picture         =   "Form1.frx":030A
      Top             =   3360
      Visible         =   0   'False
      Width           =   450
   End
   Begin VB.Image ImgPlayBmp 
      Height          =   300
      Left            =   2040
      Picture         =   "Form1.frx":088E
      Top             =   3360
      Visible         =   0   'False
      Width           =   450
   End
   Begin VB.Image imgSoundToggle 
      BorderStyle     =   1  'Fixed Single
      Height          =   300
      Left            =   2640
      Top             =   3360
      Visible         =   0   'False
      Width           =   450
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
'This Code is released as Public Domain, I will not be responsible
'for its use in any way...USE AT YOUR RISK!!!
' I used an example from James Talbot, and a couple from Mike Davis
'to put this together, as I am just learning to use the API myself.
'Having given credit where it is due, with this example I have tried
'to build an application that address some of the problems encountered
'when using the procedures in a practical application.(ok, almost a
'practical app .... it could use some more work).
' Saftey Tips for modification : Close other tasks, Save work often,
'and if you cant follow the code save it on disk and come back to
'it at a later date.(Saftey goggles are optional)
'
'
''''''''''''''''''''''''''''''''''''''''''''''' API Declares
Private Declare Function mciSendString Lib "winmm.dll" Alias "mciSendStringA" _
(ByVal lpstrCommand As String, ByVal lpstrReturnString As String, ByVal uReturnLength As Integer, ByVal hWndCallback As Integer) As Long

Private Declare Function mciGetErrorString Lib "winmm.dll" Alias "mciGetErrorStringA" _
(ByVal wError As Long, ByVal lpstrBuffer As String, ByVal uLength As Integer) As Integer
''''''''''''''''''''''''''''''''''''''''''''''''
Dim ReturnString As String ' for API
Dim mysoundopen As Boolean ' to avoid MCI error, True = mysound is open
Dim playpos As Variant     ' PLAY POSition (switches between string/integer)
Dim sndtoggle As Boolean   ' SouND Toggle  (True = Play,False = Stop)
Dim frmunload As Boolean   ' FoRM UNLOAD *see cmdQuit_Click
Dim lastdrive As String    ' used by error handler in Drive change
Dim fp As String           ' File Path
Dim fpn As String          ' File Path & Name
Dim af As Byte             ' Anti-Flicker slows down sldr1 update

Private Sub cmdQuit_Click()

On Error GoTo cmdQuit_Error

frmunload = True  ' without this variable the form would'nt unload
'properly when a file was playing, despite the code in this procedure,
'due to the DoEvents in the ImgSoundToggle_Click procedure, and or
'the return value from the API call.In either case it left a variable
'in scope and the application remained in memory(but invisible).The
'frmunload value is passed from here to just after the DoEvents Loop

'stop and close "mysound" if it has been opened.
If mysoundopen Then
 CmndStrng = "stop mysound"
 a = mciSendString(CmndStrng, ReturnString, Len(ReturnString), 0)
 If a <> 0 Then Call Check_MCI_Error(a)
 CmndStrng = "close mysound"
 a = mciSendString(CmndStrng, ReturnString, Len(ReturnString), 0)
 If a <> 0 Then Call Check_MCI_Error(a)
               End If                   '

Unload Me

Exit Sub

cmdQuit_Error:

MsgBox ("cmdQuit_Click_Error Hit!")
End

End Sub

Private Sub Dir1_Change()

With Dir1 ' anything starting with "." = "Dir1."
 
 File1.Path = .Path ' link File1 to Dir1

'add "\" when not at root Directory, in which case its aleady there.
 If Right$(.Path, Len(.Path) - 1) <> "\" Then
  fp = .Path & "\"
                                         Else
  fp = .Path
                                       End If
End With 'dir1

' hide play control and displays
imgSoundToggle.Visible = False
sldr1.Visible = False
Label1.Visible = False
Label2.Visible = False

End Sub

Private Sub Drive1_Change()

On Error GoTo Drive1_Change_Error

Dir1.Path = Drive1.Drive ' link Dir1 to Drive1

lastdrive = Drive1.Drive ' store drive letter in event of error

Exit Sub

Drive1_Change_Error:

MsgBox ("Check Your Drive!") ' you dumb ass (just kidding!)

Drive1.Drive = lastdrive ' I've done this with .Refresh, and it
                         ' seems to work, but this is probably
                         ' the proper way (and .Refresh tended
                         ' to make my floppy drive chatter like
                         ' it was not too happy with me)

End Sub

Private Sub File1_Click()

On Error GoTo File1_Click_Error

' the user can get ahead of the program here, especially using the
' keyboard so set the pointer to hourglass, and hope they'll slow down
Screen.MousePointer = 11

fpn = fp & File1.filename         'File Path & Name

                       
sldr1 = 0                         'reset misc. controls,
Label1 = "0"
Label2 = "0"
imgSoundToggle.Visible = False
sldr1.Visible = False
Label1.Visible = False
Label2.Visible = False
                                  
If mysoundopen Then               'if open, closes mysound & sets
  CmndStrng = "close mysound"     'mysoundopen to false
 a = mciSendString(CmndStrng, ReturnString, Len(ReturnString), 0)
 If a <> 0 Then Call Check_MCI_Error(a)
 mysoundopen = False
                End If

Select Case UCase(Right$(fpn, 3)) ' get file extension
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Case Is = "WAV"                    ' open mysound in wav format
 CmndStrng = "open " & fpn & " type waveaudio alias mysound"
 a = mciSendString(CmndStrng, ReturnString, Len(ReturnString), 0)
 If a <> 0 Then Call Check_MCI_Error(a)
 
 mysoundopen = True ' set mysoundopen to true since it is now open
 
 af = 100  '    anti-flicker slows down Slider in imgSoundToggle_Click
 
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Case Is = "MID"                     ' open mysound in midi format
 CmndStrng = "open " & fpn & " type sequencer alias mysound"
 a = mciSendString(CmndStrng, ReturnString, Len(ReturnString), 0)
 If a <> 0 Then Call Check_MCI_Error(a)
 
 mysoundopen = True ' set mysoundopen to true since it is now open
 
 af = 10  '    anti-flicker slows down Slider in imgSoundToggle_Click

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Case Else
Screen.MousePointer = 0
Exit Sub

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
End Select
                
'the rest is identical for WAV or MID,at this point it's assumed
'mysound is open
 
                ' get play length
 CmndStrng = "status mysound length"
 a = mciSendString(CmndStrng, ReturnString, Len(ReturnString), 0)
 If a <> 0 Then Call Check_MCI_Error(a)
 
 'get the text(cut the rest) & assign value to
 'playlen, a local(temporary) Variant type variable (huh?)
playlen = Left(ReturnString, InStr(ReturnString, Chr$(0)) - 1)
                
'set slider, labels, and pointer to correct values, show hidden controls
sldr1.Max = playlen
Label1 = playlen
Label2 = "0"
imgSoundToggle.Visible = True
sldr1.Visible = True
Label1.Visible = True
Label2.Visible = True
Screen.MousePointer = 0

Exit Sub

File1_Click_Error:
Screen.MousePointer = 0
MsgBox ("File1_Click_Error Hit!")
End

End Sub


Private Sub Form_KeyPress(KeyAscii As Integer)

' Since the Image Control can't have the focus or be in the tab order,
' this lets the user press Enter to start/stop play.(When applicable)
' When File1 has focus the user can use the up & down arrow keys and
' Enter to play files one after another, without using the mouse.

If KeyAscii = Asc(vbCr) And imgSoundToggle.Visible Then _
Call imgSoundToggle_Click


End Sub

Private Sub Form_Load()

'It didnt seem like a good Idea to have multiple Instances using the
'same API(DLL) with the same "open as" alias(mysound) so:
'eliminate multiple Instancing
If App.PrevInstance Then
 MsgBox (" A Previous Instance Exists" & vbvbCrLf _
 & " Current Instance will Terminate ")
 End
                End If

' assign a long string of spaces to ReturnString for initial API call
' after which it is always the correct length
ReturnString = Space(128)
                          
' Center the form
Me.Move (Screen.Width / 2 - Me.Width / 2), _
(Screen.Height / 2 - Me.Height / 2)

             
' for Drive Change Error
lastdrive = Drive1.Drive
                         
'Load the ImgPlayBmp.Picture as the imgSoundToggle.Picture
imgSoundToggle = ImgPlayBmp
                           
End Sub


Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)

'make sure the cmdQuit_Click event code is executed but only if if
'it hasnt been aleady(frmunload value is changed to True there)

If frmunload = False Then Call cmdQuit_Click

End Sub


Private Sub ImgPlayBmp_Click()

' no code here this control just stores the play.bmp

End Sub


Private Sub imgSoundToggle_Click()

' this is where it all really happens, especially with the DoEvents Loop
' its important to rember not to let DoEvents get called in succesion.In
' this case DoEvents is released when Play stops, and not used again
' until it is started .I had tried using a Custom Control command button
' here, but when a sound file was playing and the mouse pointer moved over
' it, it would depress automatically(but not call the Click event Procedure) Strange!
' NOTE: it is assumed that mysoundopen = True or this control would be
' hidden.

On Error GoTo imgSoundToggle_Click_Error

If sndtoggle = False Then 'NOT playing

 CmndStrng = "play mysound from 1"
 a = mciSendString(CmndStrng, ReturnString, Len(ReturnString), 0)
 If a <> 0 Then Call Check_MCI_Error(a)
 
 imgSoundToggle = imgStopBmp
 sndtoggle = True
  
                     Else 'IS playing
                     
 CmndStrng = "stop mysound"
 a = mciSendString(CmndStrng, ReturnString, Len(ReturnString), 0)
 If a <> 0 Then Call Check_MCI_Error(a)
 
 imgSoundToggle = ImgPlayBmp
 sndtoggle = False
 Exit Sub '''''''''''''''''  play has stopped so get out of here
                    End If
               
Do Until Left$(ReturnString, 7) = "stopped"

 If frmunload = True Then Exit Sub ' app is being closed, avoid assigning
    ' any variables, or form wont unload .... get out ASAP
 
 CmndStrng = "status mysound position"
 a = mciSendString(CmndStrng, ReturnString, Len(ReturnString), 0)
 If a <> 0 Then Call Check_MCI_Error(a)
 
 playpos = Left(ReturnString, InStr(ReturnString, Chr$(0)) - 1)
  
 'make sure playpos can be evaluated as a number.This was hard to debug!
  If IsNumeric(playpos) = False Then playpos = "0"
 
 ' slow down sldr1(Anti-Flicker)
 If playpos > sldr1 + af Then sldr1 = playpos
 
 Label2 = playpos
   
'check mode ... "stopped" means end loop
 a = mciSendString("status mysound mode", ReturnString, _
 Len(ReturnString), 0)
 If a <> 0 Then Call Check_MCI_Error(a)
   
 DoEvents                     ' the infamous DoEvents
 
Loop
       
sndtoggle = False              ' reset Values for play stopped
imgSoundToggle = ImgPlayBmp
sldr1 = 0
Label2 = "0"

Exit Sub

imgSoundToggle_Click_Error:

MsgBox ("imgSoundToggle_Click_Error Hit!")
End

End Sub




Private Sub imgStopBmp_Click()

' no code here this control just stores the Stop.bmp

End Sub


Private Sub Label1_Click()

' no code here I added this control while debugging
' and left it in .... Displays Sound length

End Sub


Private Sub Label2_Click()

' no code here I added this control while debugging
' and left it in  .... Displays Play Position

End Sub





Public Sub Check_MCI_Error(a)

'get and display MCI Error

ErrorRet = mciGetErrorString(a, ReturnString, Len(ReturnString))
    
If ErrorRet = 1 Then
   res% = MsgBox _
   (ReturnString, vbExclamation + vbOKOnly, "MCI Error Returned")
                End If
    
'usually its not necassary to end the progam for this but I would
'advise against compiling an EXE if your hitting an error here
'(or anywhere else for that matter!)

End Sub
